;; Problem 57
;;
;; 21 November 2003
;;
;; It is possible to show that the square root of two can be expressed
;; as an infinite continued fraction.
;;
;;  2 = 1 + 1/(2 + 1/(2 + 1/(2 + ... ))) = 1.414213...
;;
;; By expanding this for the first four iterations, we get:
;;
;; 1 + 1/2 = 3/2 = 1.5
;;  1 + 1/(2 + 1/2) = 7/5 = 1.4
;;  1 + 1/(2 + 1/(2 + 1/2)) = 17/12 = 1.41666...
;;  1 + 1/(2 + 1/(2 + 1/(2 + 1/2))) = 41/29 = 1.41379...
;;
;; The next three expansions are 99/70, 239/169, and 577/408, but the
;; eighth expansion, 1393/985, is the first example where the number
;; of digits in the numerator exceeds the number of digits in the
;; denominator.
;;
;; In the first one-thousand expansions, how many fractions contain a
;; numerator with more digits than denominator?

(defun inner-sqrt-2 (num)
  (cond ((= 0 num)
	 2)
	(t
	 (+
	  2
	  (/ 1 (inner-sqrt-2 (- num 1)))))))

(defun sqrt-2 (num)
  (+
   1
   (/ 
    1
    (inner-sqrt-2 (- num 1)))))


;(* 1.0 (sqrt-2 3))

(loop for ii from 1 to 5
      do
      (format t "ii:~a, sqrt-2:~a~&"
	      ii
	      (sqrt-2 ii)))

(defun get-exceeds (&optional (max 1000))
  (let ((res (list)))
    (loop for ii from 1 to max
	  for sq2 = (sqrt-2 ii) then (sqrt-2 ii)
	  do
	  ;(format t "sq2:~a~&" sq2)
	  (when (> (length (format nil "~d" (numerator sq2)))
		   (length (format nil "~d" (denominator sq2))))
	    (push sq2 res)))
    res))

(length (get-exceeds 1000)); 153
